import { selectAll } from 'unist-util-select';
import { copyNode } from '../utils.js';
import { remove } from 'unist-util-remove';
/**
 * Move any supplementary-material marked as position=float to end of document
 */
export function floatToEndTransform(jats) {
    var _a;
    if (!jats.body)
        return;
    const floatSupplementaryMaterial = selectAll('supplementary-material[position=float]', jats.body);
    if (floatSupplementaryMaterial.length === 0)
        return;
    (_a = jats.body.children) === null || _a === void 0 ? void 0 : _a.push({ type: 'hr' });
    floatSupplementaryMaterial.forEach((node) => {
        var _a, _b;
        const copy = copyNode(node);
        delete copy.position;
        (_b = (_a = jats.body) === null || _a === void 0 ? void 0 : _a.children) === null || _b === void 0 ? void 0 : _b.push(copy);
        node.type = '__delete__';
    });
    remove(jats.body, '__delete__');
}
